// @flow
import type { Context } from '../generate.js';
import Ast from '../ast/ast.js';
import type { JsAst, VarType } from '../ast/ast.js';
import M from '../ast/macros';
import type { JsonSchema } from '../../generated-types.js';

const not = (schema: JsonSchema, symbol: VarType, context: Context): JsAst => {
  if (schema.not) {
    return Ast.If(M.PassedCheck(schema.not, symbol, context), context.error(schema, 'not'));
  } else {
    return Ast.Empty;
  }
};

export default not;